#region Using directives

using System;
//using System.Text;
using System.Runtime.InteropServices;
using System.ComponentModel;

#endregion

namespace LEDs
{
    public class LEDs
    {
        [DllImport("coredll.dll", SetLastError = true)]
        internal static extern bool NLedGetDeviceInfo(short nID, ref NLED_SETTINGS_INFO ledInfo);

        [DllImport("coredll.dll", SetLastError = true)]
        internal static extern bool NLedSetDevice(short nID, ref NLED_SETTINGS_INFO pOutput);


        public LEDs()
        {
        }


        public int GetLedsCount()
        {
            NLED_SETTINGS_INFO ledInfo = new NLED_SETTINGS_INFO();

            if (!NLedGetDeviceInfo(0, ref ledInfo))
            {
                throw new Win32Exception(Marshal.GetLastWin32Error(), "Error getting LEDs info");
            }
            return ledInfo.LedNum;

        }


        public void ActivateLed(int ledID)
        {
            NLED_SETTINGS_INFO ledInfo = new NLED_SETTINGS_INFO();
            ledInfo.LedNum = ledID;
            ledInfo.OffOnBlink = 1;
            NLedSetDevice(2, ref ledInfo);
        }


        public void DeActivateLed(int ledID)
        {
            NLED_SETTINGS_INFO ledInfo = new NLED_SETTINGS_INFO();
            ledInfo.LedNum = ledID;
            ledInfo.OffOnBlink = 0;
            NLedSetDevice(2, ref ledInfo);
        }


        internal struct NLED_SETTINGS_INFO
        {
            public int LedNum;
            public int OffOnBlink;
            public int TotalCycleTime;
            public int OnTime;
            public int OffTime;
            public int MetaCycleOn;
            public int MetaCycleOff;
        }

    }

}